import java.io.*; 
import java.net.*; 

class TCPChat_halfServer extends Thread {
	private Socket connectionSocket;
	private BufferedReader inFromRemote;

	public TCPChat_halfServer(Socket s) throws Exception {
		connectionSocket = s;
		inFromRemote = new BufferedReader(new InputStreamReader(connectionSocket.getInputStream())); 
		start(); // Calls run()
	}

	public void run() {
		try {
			while(true) { 
				// read the incoming information and display it
				String clientSentence = inFromRemote.readLine(); 
				System.out.println("user > " + clientSentence);
			}
		} catch (IOException e) {
		}
	}
}

class TCPChat_halfClient extends Thread {
	private Socket clientSocket;
	private BufferedReader inFromLocal;
	private	DataOutputStream outToServer;
	
	public TCPChat_halfClient(Socket s) throws Exception {

		clientSocket = s;

		inFromLocal = new BufferedReader(new InputStreamReader(System.in));
		outToServer = new DataOutputStream(clientSocket.getOutputStream()); 
		start(); // Calls run()
	}

	public void run() {
		try {
			while(true) { 
				// send what the user writes
				String sentence = inFromLocal.readLine(); 
				outToServer.writeBytes(sentence + '\n');
			}
		} catch (IOException e) {
		}
	} 
}

///////////////////////////////////////////////

class TCPChat_clientServer { 

	public static void main(String args[]) throws Exception {

		int port;
		Socket connectionSocket;

		if ((args.length<1)||(args.length>2)) {
			System.out.println("error");
			System.exit(0);
		}
		if (args.length==1) {
			port = Integer.parseInt(args[0]);
			ServerSocket welcomeSocket = new ServerSocket(port);
			// wait for connections 
			connectionSocket = welcomeSocket.accept();
		}
		else {
			port = Integer.parseInt(args[1]);
			connectionSocket = new Socket(args[0], port);
		}

		// create the two threads 
		new TCPChat_halfServer(connectionSocket);
		new TCPChat_halfClient(connectionSocket);
	}
}

